ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.8 by root, Tue Dec 7 19:55:56 2010 UTC vs.
Revision 1.25 by root, Tue Dec 28 18:03:47 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
52postconfigure() { : ; } 52postconfigure() { : ; }
53postbuild() { : ; } 53postbuild() { : ; }
54postinstall() { : ; } 54postinstall() { : ; }
55 55
56# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
60 64
61############################################################################# 65#############################################################################
62# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
63 73
64# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
66$VERSION=0.1 76$VERSION=0.92
67 77
68BZ2=bz2 78BZ2=bz2
69BZIP2=bzip2 79BZIP2=bzip2
70 80
71fatal() { 81fatal() {
104############################################################################# 114#############################################################################
105# clean 115# clean
106 116
107distclean() { 117distclean() {
108 verblock <<EOF 118 verblock <<EOF
109deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 120EOF
111 121
112 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
113} 123}
114 124
115############################################################################# 125#############################################################################
116# download/configure/compile/install perl 126# download/configure/compile/install perl
117 127
118clean() { 128clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 136}
121 137
122fetch() { 138fetch() {
123 rcd "$STATICPERL" 139 rcd "$STATICPERL"
124 140
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
137trying $URL 153trying $URL
138EOF 154EOF
139 155
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 162 fi
146 163
147 verblock <<EOF 164 verblock <<EOF
148unpacking perl 165unpacking perl
149EOF 166EOF
150 167
151 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 174 rmdir -p unpack
157 fi 175 fi
158} 176}
159 177
160# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
161sedreplace() { 179sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
163 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
164} 209}
165 210
166configure() { 211configure() {
167 fetch 212 fetch
168 213
174configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 220EOF
176 221
177 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
178 223
179 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
180 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
181 # I hate them 228 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 231
185 preconfigure 232 preconfigure
186 233
190 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
191 -Uusedl \ 238 -Uusedl \
192 -Uusethreads \ 239 -Uusethreads \
193 -Uuseithreads \ 240 -Uuseithreads \
194 -Uusemultiplicity \ 241 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 242 -Uusesfio \
197 -Uuseshrplib \ 243 -Uuseshrplib \
198 -Dcppflags="$PERL_CPPFLAGS" \ 244 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 245 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 253 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 256 -Uman1dir \
212 -Uman3dir \ 257 -Uman3dir \
213 -Usiteman1dir \ 258 -Usiteman1dir \
214 -Usiteman3dir \ 259 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 264 $PERL_CONFIGURE \
265 -Duseperlio \
220 -dE || fatal "Configure failed" 266 -dE || configure_failure
221 267
222 sedreplace ' 268 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
225 ' config.sh 271 ' config.sh
240building $STATICPERL/src/perl-$PERL_VERSION 286building $STATICPERL/src/perl-$PERL_VERSION
241EOF 287EOF
242 288
243 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
244 290
245 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
246 292
247 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
248} 294}
249 295
250install() { 296install() {
251 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 297 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
252
253 build 298 build
254 299
255 verblock <<EOF 300 verblock <<EOF
256installing $STATICPERL/src/perl-$PERL_VERSION 301installing $STATICPERL/src/perl-$PERL_VERSION
257to $PERL_PREFIX 302to $PERL_PREFIX
258EOF 303EOF
259 304
260 rm -rf "$PERL_PREFIX" 305 ln -sf "perl/bin/" "$STATICPERL/bin"
261 306 ln -sf "perl/lib/" "$STATICPERL/lib"
307
308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
309 rm -rf "$PERL_PREFIX" # by this rm -rf
310
262 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
263 312
264 rcd "$PERL_PREFIX" 313 rcd "$PERL_PREFIX"
265 314
266 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
267 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
268make install UNINST=1 317"$MAKE" || exit
318
269if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
270 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
271 make perl 321 if "$MAKE" perl; then
322 mv perl "$PERL_PREFIX"/bin/perl~ \
272 rm -f "$PERL_PREFIX"/bin/perl 323 && rm -f "$PERL_PREFIX"/bin/perl \
273 make -f Makefile.aperl inst_perl 324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
274 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
326 else
327 "$MAKE" -f Makefile.aperl map_clean
328 exit 1
329 fi
275fi 330fi
331
332"$MAKE" install UNINST=1
276EOF 333EOF
277 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
278 335
279 # trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
280 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
281 338
282 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 339 "$PERL_PREFIX"/bin/perl -MCPAN -e '
283 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 340 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 341 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<init>); 342 CPAN::Shell->o (conf => q<init>);
286 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
287 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 344 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
288 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 345 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
289 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 346 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
290 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 347 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
291 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 348 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
292 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 349 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
293 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 350 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
294 CPAN::Shell->o (conf => q<commit>); 351 CPAN::Shell->o (conf => q<commit>);
295 ' || fatal "error while initialising CPAN" 352 ' || fatal "error while initialising CPAN"
296 353
354 touch "$PERL_PREFIX/staticstamp.install"
355 fi
356
357 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
297 NOCHECK_INSTALL=+ 358 NOCHECK_INSTALL=+
298 instcpan $STATICPERL_MODULES 359 instcpan $STATICPERL_MODULES
299 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 360 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
300 361
301 postinstall || fatal "postinstall hook failed" 362 postinstall || fatal "postinstall hook failed"
302 363
303 touch "$PERL_PREFIX/staticstamp.install" 364 touch "$PERL_PREFIX/staticstamp.postinstall"
365 fi
304} 366}
305 367
306############################################################################# 368#############################################################################
307# install a module from CPAN 369# install a module from CPAN
308 370
335 for mod in "$@"; do 397 for mod in "$@"; do
336 echo 398 echo
337 echo $mod 399 echo $mod
338 ( 400 (
339 rcd $mod 401 rcd $mod
340 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
341 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
342 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
343 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
344 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
345 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
346 exit 0 408 exit 0
347 ) || exit $? 409 ) || exit $?
348 done 410 done
349} 411}
350 412
351############################################################################# 413#############################################################################
352# main 414# main
353 415
354podusage() { 416podusage() {
355 echo 417 echo
418
356 if [ -e "$PERL_PREFIX/bin/perl" ]; then 419 if [ -e "$PERL_PREFIX/bin/perl" ]; then
357 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 420 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
358 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 421 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
359 2>/dev/null && exit 422 2>/dev/null && exit
360 fi 423 fi
424
361 # try whatever perl we can find 425 # try whatever perl we can find
362 perl -MPod::Usage -e \ 426 perl -MPod::Usage -e \
363 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 427 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
364 2>/dev/null && exit 428 2>/dev/null && exit
365 429
366 fatal "displaying documentation requires a working perl - try '$0 install' first" 430 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
367} 431}
368 432
369usage() { 433usage() {
370 podusage 0 434 podusage 0
371} 435}
381} 445}
382 446
383bundle() { 447bundle() {
384 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 448 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
385 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 449 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
450 CACHE="$STATICPERL/cache"
451 mkdir -p "$CACHE"
386 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 452 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
387} 453}
388 454
389if [ $# -gt 0 ]; then 455if [ $# -gt 0 ]; then
390 while [ $# -gt 0 ]; do 456 while [ $# -gt 0 ]; do
391 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 457 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
392 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 458 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
393 459
394 command="${1#--}"; shift 460 command="${1#--}"; shift
395 case "$command" in 461 case "$command" in
462 version )
463 echo "staticperl version $VERSION"
464 ;;
396 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
397 verblock <<EOF
398$command
399EOF
400 ( "$command" ) 466 ( "$command" ) || exit
401 ;; 467 ;;
402 instsrc ) 468 instsrc )
403 ( instsrc "$@" ) 469 ( instsrc "$@" ) || exit
404 exit 470 exit
405 ;; 471 ;;
406 instcpan ) 472 instcpan )
407 ( instcpan "$@" ) 473 ( instcpan "$@" ) || exit
408 exit 474 exit
409 ;; 475 ;;
410 cpan ) 476 cpan )
411 ( install ) 477 ( install ) || exit
412 "$PERL_PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
413 exit 479 exit
414 ;; 480 ;;
415 mkbundle ) 481 mkbundle )
416 ( install ) 482 ( install ) || exit
417 bundle "$@" 483 bundle "$@"
418 exit 484 exit
419 ;; 485 ;;
420 mkperl ) 486 mkperl )
421 ( install ) 487 ( install ) || exit
422 bundle --perl "$@" 488 bundle --perl "$@"
489 exit
490 ;;
491 mkapp )
492 ( install ) || exit
493 bundle --app "$@"
423 exit 494 exit
424 ;; 495 ;;
425 help ) 496 help )
426 podusage 2 497 podusage 2
427 ;; 498 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines